- NAME
- SYNOPSIS
- DESCRIPTION
- NOTES
- RETURN VALUES
- SEE ALSO
- COPYRIGHT

# NAME

SSL_get_session, SSL_get0_session, SSL_get1_session - retrieve TLS/SSL session data

# SYNOPSIS

     #include <openssl/ssl.h>

     SSL_SESSION *SSL_get_session(const SSL *ssl);
     SSL_SESSION *SSL_get0_session(const SSL *ssl);
     SSL_SESSION *SSL_get1_session(SSL *ssl);

# DESCRIPTION

SSL_get_session() returns a pointer to the SSL_SESSION actually used in ssl. The reference count of the SSL_SESSION is not incremented, so that the pointer can become invalid by other operations.

SSL_get0_session() is the same as SSL_get_session().

SSL_get1_session() is the same as SSL_get_session(), but the reference count of the SSL_SESSION is incremented by one.

# NOTES

The ssl session contains all information required to re-establish the connection without a new handshake.

A session will be automatically removed from the session cache and marked as non-resumable if the connection is not closed down cleanly, e.g. if a fatal error occurs on the connection or SSL_free(3).

SSL_get0_session() returns a pointer to the actual session. As the reference counter is not incremented, the pointer is only valid while the connection is in use. If SSL_free(3) is called, the session may be removed completely (if considered bad), and the pointer obtained will become invalid. Even if the session is valid, it can be removed at any time due to timeout during SSL_SESSION_free(3) must be explicitly called once to decrement the reference count again.

SSL_SESSION objects keep internal link information about the session cache list, when being inserted into one SSL_CTX object's session cache. One SSL_SESSION object, regardless of its reference count, must therefore only be used with one SSL_CTX object (and the SSL objects created from this SSL_CTX object).

# RETURN VALUES

The following return values can occur:

NULL

  There is no session available in ssl.

Pointer to an SSL_SESSION

  The return value points to the data of an SSL session.

# SEE ALSO

SSL_free(3), SSL_SESSION_free(3)

# COPYRIGHT

Copyright 2000-2018 The OpenSSL Project Authors. All Rights Reserved.

Licensed under the OpenSSL license (the "License"). You may not use this file except in compliance with the License. You can obtain a copy in the file LICENSE in the source distribution or at https://www.openssl.org/source/license.html.